/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from input-method-unstable-v1.xml by mir_wayland_generator
 */

#ifndef MIR_FRONTEND_WAYLAND_INPUT_METHOD_UNSTABLE_V1_XML_WRAPPER
#define MIR_FRONTEND_WAYLAND_INPUT_METHOD_UNSTABLE_V1_XML_WRAPPER

#include <optional>

#include "mir/fd.h"
#include <wayland-server-core.h>

#include "mir/wayland/resource.h"
#include "mir/wayland/global.h"

namespace mir
{
namespace wayland
{

class InputMethodContextV1;
class InputMethodV1;
class InputPanelV1;
class InputPanelSurfaceV1;

class InputMethodContextV1 : public Resource
{
public:
    static char const constexpr* interface_name = "zwp_input_method_context_v1";

    static InputMethodContextV1* from(struct wl_resource*);

    InputMethodContextV1(InputMethodV1 const& parent);
    virtual ~InputMethodContextV1();

    void send_surrounding_text_event(std::string const& text, uint32_t cursor, uint32_t anchor) const;
    void send_reset_event() const;
    void send_content_type_event(uint32_t hint, uint32_t purpose) const;
    void send_invoke_action_event(uint32_t button, uint32_t index) const;
    void send_commit_state_event(uint32_t serial) const;
    void send_preferred_language_event(std::string const& language) const;

    struct Opcode
    {
        static uint32_t const surrounding_text = 0;
        static uint32_t const reset = 1;
        static uint32_t const content_type = 2;
        static uint32_t const invoke_action = 3;
        static uint32_t const commit_state = 4;
        static uint32_t const preferred_language = 5;
    };

    struct Thunks;

    static bool is_instance(wl_resource* resource);

private:
    virtual void commit_string(uint32_t serial, std::string const& text) = 0;
    virtual void preedit_string(uint32_t serial, std::string const& text, std::string const& commit) = 0;
    virtual void preedit_styling(uint32_t index, uint32_t length, uint32_t style) = 0;
    virtual void preedit_cursor(int32_t index) = 0;
    virtual void delete_surrounding_text(int32_t index, uint32_t length) = 0;
    virtual void cursor_position(int32_t index, int32_t anchor) = 0;
    virtual void modifiers_map(struct wl_array* map) = 0;
    virtual void keysym(uint32_t serial, uint32_t time, uint32_t sym, uint32_t state, uint32_t modifiers) = 0;
    virtual void grab_keyboard(struct wl_resource* keyboard) = 0;
    virtual void key(uint32_t serial, uint32_t time, uint32_t key, uint32_t state) = 0;
    virtual void modifiers(uint32_t serial, uint32_t mods_depressed, uint32_t mods_latched, uint32_t mods_locked, uint32_t group) = 0;
    virtual void language(uint32_t serial, std::string const& language) = 0;
    virtual void text_direction(uint32_t serial, uint32_t direction) = 0;
};

class InputMethodV1 : public Resource
{
public:
    static char const constexpr* interface_name = "zwp_input_method_v1";

    static InputMethodV1* from(struct wl_resource*);

    InputMethodV1(struct wl_resource* resource, Version<1>);
    virtual ~InputMethodV1();

    void send_activate_event(struct wl_resource* id) const;
    void send_deactivate_event(struct wl_resource* context) const;

    void destroy_and_delete() const;

    struct Opcode
    {
        static uint32_t const activate = 0;
        static uint32_t const deactivate = 1;
    };

    struct Thunks;

    static bool is_instance(wl_resource* resource);

    class Global : public wayland::Global
    {
    public:
        Global(wl_display* display, Version<1>);

        auto interface_name() const -> char const* override;

    private:
        virtual void bind(wl_resource* new_zwp_input_method_v1) = 0;
        friend InputMethodV1::Thunks;
    };

private:
};

class InputPanelV1 : public Resource
{
public:
    static char const constexpr* interface_name = "zwp_input_panel_v1";

    static InputPanelV1* from(struct wl_resource*);

    InputPanelV1(struct wl_resource* resource, Version<1>);
    virtual ~InputPanelV1();

    void destroy_and_delete() const;

    struct Thunks;

    static bool is_instance(wl_resource* resource);

    class Global : public wayland::Global
    {
    public:
        Global(wl_display* display, Version<1>);

        auto interface_name() const -> char const* override;

    private:
        virtual void bind(wl_resource* new_zwp_input_panel_v1) = 0;
        friend InputPanelV1::Thunks;
    };

private:
    virtual void get_input_panel_surface(struct wl_resource* id, struct wl_resource* surface) = 0;
};

class InputPanelSurfaceV1 : public Resource
{
public:
    static char const constexpr* interface_name = "zwp_input_panel_surface_v1";

    static InputPanelSurfaceV1* from(struct wl_resource*);

    InputPanelSurfaceV1(struct wl_resource* resource, Version<1>);
    virtual ~InputPanelSurfaceV1();

    void destroy_and_delete() const;

    struct Position
    {
        static uint32_t const center_bottom = 0;
    };

    struct Thunks;

    static bool is_instance(wl_resource* resource);

private:
    virtual void set_toplevel(struct wl_resource* output, uint32_t position) = 0;
    virtual void set_overlay_panel() = 0;
};

}
}

#endif // MIR_FRONTEND_WAYLAND_INPUT_METHOD_UNSTABLE_V1_XML_WRAPPER
